#!/bin/bash

#set -e

# VI/ELVIS/VIM set tabstop=4

ME=mail2sh
CONFIGFILE=Mail2shell.conf
MEHOME=/var/lib/mail2sh/
MEUSER=${ME}
MEGROUP=mail2sh
ETCHOME=/etc/mail2sh/
MEDOC=/usr/share/doc/mail2sh/
sudo=/etc/sudoers

case "$1" in
	configure)

		echo "#################################################################################"
		echo " This script only allows you to install Mail2shell if it's a first installation."
		echo " Otherwise, it's not guaranteed to work properly."
		echo " It's therefore recommended to consult the documentation for any updates."
		echo "   -> https://mans.gyptis.org/w/Mail2sh  <-"
		echo "#################################################################################"
		###############
		### ADDUSER ###
		###############
		echo 'Adduser mail2sh: '
	
		# Je verifie si j'existe, c'est-a-dire qu'il s'agisse bien
		# de moi et pas d'un autre mail2sh !!
		#if  grep -q "^mail2sh::${MEHOME}" /etc/passwd ; then
		if  id $MEUSER > /dev/null 2>&1 ; then
			# Je verifie si mail2sh exist, si oui, alors je cris!!
			echo '************************************************'
			echo
			echo  $ME detected, continious setup... 
			echo
			echo '************************************************'
			#echo Remove account exist.
			#echo ' '
			#deluser --remove-home $ME
	
		else
		   addgroup --quiet $MEGROUP &> /dev/null
		   adduser  --quiet --system --home $MEHOME --ingroup $MEGROUP --shell /bin/sh $MEUSER &> /dev/null
		   #adduser --system --home $MEHOME --ingroup $MEGROUP --shell /bin/sh $ME &> /dev/null 
		fi
	
	
	
		##############
		### CONFIG ###
		##############

		### /etc/Mail2sh.conf ###
		cp -ufa /usr/share/doc/mail2sh/examples/etc/${ME}.noauth $ETCHOME
		if [ ! -f $ETCHOME/${CONFIGFILE} ] ; then
			cp -afvu ${MEDOC}/examples/etc/${CONFIGFILE}.single_user $ETCHOME/$CONFIGFILE
			if  [ $?  == "0" ]; then
				echo Changing passwords $ETCHOME/$CONFIGFILE
				PASSWD=$(head -c 10 /dev/urandom | base64 | tr -dc '[:alnum:]' | head -c 10)
				sed -i -r -e 's/(password)+([ \t]*).*/\1 \2 '${PASSWD}'/' $ETCHOME/$CONFIGFILE
			else
				echo "  "WARNING: The configuration file could not be copied to $ETCHOME/$CONFIGFILE.
				echo "  "You may need to do this manually.
				echo "    "try with : cp -f ${MEDOC}/examples/etc/${CONFIGFILE}.single_user $ETCHOME/$CONFIGFILE
				echo " Don't forget to change the default passwords!"
				echo " Don't forget to change the default passwords!"
				echo " Don't forget to change the default passwords!"
			fi
		else
			echo Existing configuration file, if you are updating Mail2shell, ignore it.
		fi
		### Mailing-list / List-archives ###
		#echo -n "Rebuilding master index page ... "
		#/usr/lib/lists-archives/updatemail -x
		#echo "done."

		### .forward / procmail ###
		#sed -i -r -e 's%/var/lib/mail2sh%'${MEHOME}'%' ${MEHOME}/.forward
		echo '"|/usr/bin/sudo '${MEHOME}'/mail2shell"' > ${MEHOME}/.forward

	
		############
		### SUDO ###
		############
	
		echo Sudoers config...
		#cp -ua $sudo $sudo.$$
		#sed -e '/#-- MAIL2SH begin/,/#-- MAIL2SH end/d' $sudo > ${sudo}.new
		sed -i -e '/#-- MAIL2SH begin/,/#-- MAIL2SH end/d' /etc/sudoers
		cp -afu /usr/share/doc/mail2sh/examples/sudo/mail2sh /etc/sudoers.d/mail2sh && echo "  copy config mail2shell in sudoers.d/ ok"
		sed -i -r -e "s%^(mail2sh) (ALL = \(root\) NOPASSWD: )(.*)$%${MEUSER} \2 ${MEHOME}mail2shell%" /etc/sudoers.d/mail2sh && echo "  change user in sudoers.d/mail2sh ok"
		chown root:root /etc/sudoers.d/mail2sh
		chmod 0440 /etc/sudoers.d/mail2sh
	
		#cat $MEDOC/examples/sudo/sudoers >> ${sudo}.new
		#mv ${sudo}.new ${sudo}
		#chmod 0440 ${sudo}
	
	
	
		# DROITS
		echo User rights
		chown -R $MEUSER:$MEGROUP $MEHOME $ETCHOME && echo "  chown -R $_ ok"
		chmod 0750 -R $ETCHOME && echo "  chmod 0750 -R $_ ok"
		chmod 0555 -R $MEHOME && echo "  chmod 0555 -R $_ ok"

		# We prevent mail2shell from being able to modify its own source ;)
		chown root:mail2sh -R $MEHOME/{.forward,mail2shell} $ETCHOME/${CONFIGFILE} && echo "  chown root:mail2sh -R $_ ok"
		#chmod 0444 -R ${MEHOME}locales/ && echo "  chmod 0444 -R $_ ok"
	
		#exit 1
	;;

  abort-upgrade|abort-remove|abort-deconfigure)
	exit 0
	;;

  *)
	echo "postinst called with unknown argument \`$1'" >&2
	echo "Launch : $0 configure ..."
	exit 0
	;;
esac
